function ClusterIndices = ClusterScanPoints(points_local)

% points is a 2xN array of points
% clusters is a cell array. cluster{k} is a vector containing the indices of the k-th cluster

if isempty(points_local)
    ClusterIndices = {};
    return;
end

SameObstaclePointsMaxSeparation = 0.05; % Should be relative

pointsCount = size(points_local,2);
if pointsCount <= 1
    clusters{1} = points_local;
    return;
end
xDiff = diff(points_local(1,:));
yDiff = diff(points_local(2,:));
adjDistsSq = xDiff.^2 + yDiff.^2;
breakPoints = [(adjDistsSq > SameObstaclePointsMaxSeparation), true];
endIndices = find(breakPoints);

startIndex = 1;
count = 0;
for endIndex = endIndices
    count = count + 1;
    ClusterIndices{count} = startIndex:endIndex;
    startIndex = endIndex + 1;
end
