function InitiateParticles_SLAM(n, pos, th, wt)
global Particles

% Initiate n number of particles at the position (0,0) with th=0 (local reference coordinate of the particle)

% Structure Particles
%                    .N     -- number of particles
%                    .pos   -- 2xN vector : position of the particles
%                    .th    -- 1xN vector : theta-coordinate of the particles
%                    .wt    -- 1xN vector : weight associated with each particle
%                    .WinnerIndex
%                    .World{p} -- A world structure defining the map maintained by particle 'p' (World structure described below)

if nargin == 1
    pos = [0 0]';
    th = 0;
    wt = 1;
end

Particles.N = n;
Particles.pos = repmat(pos, [1 n]);
Particles.th = th*ones([1 n]);
Particles.wt = wt*ones([1 n]);
for a = 1:n
    Particles.World{a}.N = 0;
end
Particles.WinnerIndex = 1;
