function dists = findDist_PointsElement(WorldElement, points)
% Not used!!

pointCount = size(points, 2);
dists = inf(1, pointCount);

switch WorldElement.type


    case 'LineSegment'

        LineEnds = WorldElement.ends;
        SegmentVector = WorldElement.etc.SegmentVector; %LineEnds(:,2) - LineEnds(:,1);
        SegmentLength = WorldElement.etc.SegmentLength; %sqrt(sum(SegmentVector.^2));
        SegmentUnitVector = WorldElement.etc.SegmentUnitVector; %SegmentVector / SegmentLength;
        pointsVector_1 = points - repmat(LineEnds(:,1), [1 pointCount]);
        pointsProjections = sum( pointsVector_1 .* repmat(SegmentUnitVector, [1 pointCount]) );

        outsideTags_1 = (pointsProjections < 0);
        outsideTags_2 = (pointsProjections > SegmentLength);
        insideTags = not( outsideTags_1 | outsideTags_2);

        dists = inf(1, pointCount);
        dists(outsideTags_1) = sqrt(sum( (points(:,outsideTags_1) - repmat(LineEnds(:,1), [1 sum(outsideTags_1)])) .^ 2));
        dists(outsideTags_2) = sqrt(sum( (points(:,outsideTags_2) - repmat(LineEnds(:,2), [1 sum(outsideTags_2)])) .^ 2));

        insideTagsCount = sum(insideTags);
        if insideTagsCount
            an = WorldElement.etc.an; %a / mag;
            bn = WorldElement.etc.bn; %b / mag;
            cn = WorldElement.etc.cn; %c / mag;
            dists(insideTags) = abs( an*points(1,insideTags) + bn*points(2,insideTags) + cn );
        end


    case 'CircularArk'

        ArkAngles = WorldElement.anglerange;
        if ArkAngles(2) <= ArkAngles(1) % This should have been done before - no need to do it here again!
            ArkAngles(2) = ArkAngles(2) + 2*pi;
        end

        rs = sqrt(sum( (points - repmat(WorldElement.c, [1 pointCount])) .^ 2));
        ths = atan2( points(2,:)-WorldElement.c(2) , points(1,:)-WorldElement.c(1) );
        lowAngleIndices = (ths <= ArkAngles(1));
        ths(lowAngleIndices) = ths(lowAngleIndices) + 2*pi;

        outsideTags = (ths > ArkAngles(2));
        insideTags = not(outsideTags);

        outsidePointsCount = sum(outsideTags);
        dists = inf(1, pointCount);
        endPoint1 = WorldElement.etc.endPoints(:,1); %WorldElement.c + WorldElement.r*[cos(ArkAngles(1)); sin(ArkAngles(1))];
        endPoint2 = WorldElement.etc.endPoints(:,2); %WorldElement.c + WorldElement.r*[cos(ArkAngles(2)); sin(ArkAngles(2))];
        dists(outsideTags) = sqrt(min([ sum( (points(:,outsideTags) - repmat(endPoint1, [1 outsidePointsCount])) .^ 2);
            sum( (points(:,outsideTags) - repmat(endPoint2, [1 outsidePointsCount])) .^ 2)  ]));
        dists(insideTags) = abs( rs(insideTags) - WorldElement.r );

end
