function result = isIntersect_Segments(s1, s2, Strict)

% s1 and s2 are structures
%           .v -- vertices (2x2 matrix with each column being the vertices)
%           .a, .b, .c -- coefficients defining the line

% Strict: 3 - no touch allowed
%         2 - only end-to-end touch allowed
%         1 - only end-to-body touch allowed
%         0 - all form of end touches allowed
%         

if nargin<3
   Strict = 3;
end
del = 1e-6;

r1 = s1.a * s2.v(1,:)  +  s1.b * s2.v(2,:)  +  s1.c;
r2 = s2.a * s1.v(1,:)  +  s2.b * s1.v(2,:)  +  s2.c;

if Strict==3 && r1(1)*r1(2)<=del  &&  r2(1)*r2(2)<=del
    result = 1;
    return;
elseif Strict==2 && ( (r1(1)*r1(2)<=del  &&  r2(1)*r2(2)<=del) && ~(abs(r1(1)*r1(2))<=del  &&  abs(r2(1)*r2(2))<=del) )
    result = 1;
    return;
elseif Strict==1 && ( (r1(1)*r1(2)<=del  &&  r2(1)*r2(2)<=del) && ~( xor(abs(r1(1)*r1(2))<=del ,  abs(r2(1)*r2(2))<=del) ) )
    result = 1;
    return;
elseif Strict==0 && abs(r1(1)*r1(2))<del  &&  abs(r2(1)*r2(2))<del
    result = 1;
    return;
else
    result = 0;
end
