function drawScene(option)
global World Particles
global Figure_H World_H Particles_H

if isempty(Figure_H)
    Figure_H = figure;
else
    Figure_H = figure(Figure_H);
end
axis equal;
hold on;

switch option
    
    
    case 'world'
        
        for k = 1:World.N
            try
                delete(World_H{k});
            end
            switch World.element{k}.type
                case 'LineSegment'
                    World_H{k} = plot(World.element{k}.ends(1,:), World.element{k}.ends(2,:), 'r-');
                case 'CircularArk'
                    pts = Circle(World.element{k}.r, World.element{k}.c, World.element{k}.anglerange);
                    World_H{k} = plot(pts(1,:), pts(2,:), 'r-');
            end
        end
        
        
    case 'particles'

        try
            delete(Particles_H.points);
        end
        Particles_H.points = plot(Particles.x, Particles.y, 'b.');
        
        
    case 'particles_weights'
        
        maxWt = max(Particles.wt);
        for a=1:Particles.N
            if Particles.wt(a) < 0.8*maxWt
                continue;
            end
            try
                delete(Particles_H.wts{a});
            end
            Particles_H.wts{a} = text(Particles.x(a), Particles.y(a), sprintf('(%0.3f,%0.3f)',Particles.th(a),Particles.wt(a)));
        end

        
end
