function sp = ShortestPath_Dijkstra(E, s, t)
% E is a Nx3 matrix:
%                   The first 2 colums give node number that defines the edges
%                   The third colum give the edge costs

NodeCount = max(union(E(:,1), E(:,2)));
NodesNos = 1:NodeCount;

for a = NodesNos
    EdgeIndices = (E(:,1)==NodesNos(a));
    SelectEdges = E(EdgeIndices,:);
    Neighbors{a}.Nos = union(SelectEdges(:,2),[])';
    Neighbors{a}.Dist = [];
    for b = 1:length(Neighbors{a}.Nos)
        Neighbors{a}.Dist(b) = min(SelectEdges(SelectEdges(:,2)==Neighbors{a}.Nos(b),3));
    end
%     a,
%     disp([Neighbors{a}.Nos', Neighbors{a}.Dist']);
end

d = inf([1 NodeCount]);
d(s) = 0;

OpenNodes = NodesNos;
ClosedNodes = [];

while length(OpenNodes) > 0
    
    [MinDist, ExpandIndex] = min(d(OpenNodes));
    if isinf(MinDist)
        break;
    end
    NodeToExpand = OpenNodes(ExpandIndex);
    
    for a = 1:length(Neighbors{NodeToExpand}.Nos)
        ThisNeighbor = Neighbors{NodeToExpand}.Nos(a);
        chk_d = d(NodeToExpand) + Neighbors{NodeToExpand}.Dist(a);
        if chk_d < d(ThisNeighbor)
            d(ThisNeighbor) = chk_d;
        end
    end
    
    OpenNodes = setdiff(OpenNodes, NodeToExpand);
    
end

sp = [];
if isinf(d(t))
    return;
end

traceNode = t;
sp = traceNode;
while traceNode ~= s
    
    ParentNodes = [];
    DistFromParents = [];
    for a = setdiff(NodesNos, traceNode)
        i = find(Neighbors{a}.Nos == traceNode);
        if ~isempty(i)
            ParentNodes = [ ParentNodes, a ];
            DistFromParents = [ DistFromParents, Neighbors{a}.Dist(i) ];
        end
    end
%     traceNode,
%     ParentNodes,
%     d(ParentNodes),
    [dNext, Index] = min( d(ParentNodes) + DistFromParents );
    traceNode = ParentNodes(Index);
    sp = [traceNode, sp];
    
end
% d,
% Neighbors{4},
