
function RobotComputeAndSetVelocity_GroundTruth(speed)
global Control

if nargin < 1
    speed = Control.params.RobotSpeed;
end

robotData = Robot_Communicate('getData_Pose');
currentPos = robotData.p + Control.params.FeedbackLinearizationDistance*[cos(robotData.theta); sin(robotData.theta)];
searchAheadPointIndices = ...
    Control.PathPoints.NowIndex:min([ Control.PathPoints.NowIndex + round(Control.params.SearchAheadDistForClosestPoint/Control.params.PathDiscretizationResolution), ...
    size(Control.PathPoints.points,2) ]);
distSqFromAheadPoints = sum( (Control.PathPoints.points(:,searchAheadPointIndices) - repmat(currentPos, [1 length(searchAheadPointIndices)])) .^ 2);
[nearestPtDistSq, nearestPtIndex] = min(distSqFromAheadPoints);

Control.PathPoints.NowIndex = searchAheadPointIndices(nearestPtIndex);

targetPointIndex = min([ Control.PathPoints.NowIndex+round(Control.params.TargetPointDistanceAhead/Control.params.PathDiscretizationResolution), ...
    size(Control.PathPoints.points,2) ]);
targetPoint = Control.PathPoints.points(:,targetPointIndex);

globalVel = targetPoint - currentPos;
globalVel = speed * globalVel / norm(globalVel);

localVel = [cos(robotData.theta), sin(robotData.theta); -sin(robotData.theta), cos(robotData.theta)] * globalVel;
lastVel = [localVel(1), localVel(2)/Control.params.FeedbackLinearizationDistance];
Robot_Communicate('setVelocity', lastVel);
