function test1
global World Particles Boundary VGraph Control
SetSearchPaths;

% Structure World
%                .N                 -- Number of elements in the world
%                .element{k}        -- A structure defining a line/curve
%
%                           .type       =  'LineSegment'
%                           .ends       -- A 2x2 matrix each each column representing a vertex
%
%                           .type       = 'CircularArk'
%                           .c          -- center
%                           .r          -- radius
%                           .anglerange -- a 1x2 vector of [startAngle, endAngle]

% World.N = 3;
% 
% World.element{1}.type = 'LineSegment';
% World.element{1}.ends = [ -2 1 ; -2 -3 ]';
% 
% World.element{2}.type = 'LineSegment';
% World.element{2}.ends = [ 1 0 ; 3 5 ]';
% 
% World.element{3}.type = 'CircularArk';
% World.element{3}.c = [ 0 , 0.5 ]';
% World.element{3}.r = 1;
% World.element{3}.anglerange = [0 2*pi];
% 
% Boundary = [-4 4; -4 4];

Control.params.RobotRadius = 0.1;
Control.params.FeedbackLinearizationDistance = 0.05;
Control.params.Clearance_KnownObstacles = 0.05; % 0.2;
Control.params.Clearance_GeneratedObstacles = 0.2;
Control.params.PathDiscretizationResolution = 0.03;

InitiateUObstacle('project2_sample.spec');
GenerateWorld;
GenerateObstacles;

DrawScene('initiate');
DrawScene('World');

% -------------------------------------------------------

VGraph_Initiate;

VGraph_ComputeLeastCostPath;
ValidPath = VGraph_CheckLeastCostPath;
%ValidPath.Segment(1),

while ~ValidPath.isValid
    
    for a = 1:length(ValidPath.Segment)
        if ~ValidPath.Segment(a).isValid
            % Remove that segment
            VGraph_RemoveBlockedEdges(VGraph.LeastCostPath(a));
            % Add new obstacle
            for b=1:length(ValidPath.Segment(a).BlockObstacles)
                VGraph_AddObstacle(ValidPath.Segment(a).BlockObstacles(b));
            end
        end
    end
%     VGraph.InterClusterEdges{4,2},
%     break;
    VGraph_ComputeLeastCostPath;
    ValidPath = VGraph_CheckLeastCostPath;
end

DiscretizeLeastCostPath;

DrawScene('Obstacles');
DrawScene('VGraph');
DrawScene('Path');

% -------------------------------------------------------


% while (1)
%     disp('Click to enter points');
%     [x,y] = ginput;
%     dists = ComputeMinDistFromWalls([x';y']);
%     disp(sprintf('Mean Dist: %f', mean(dists)));
%     pause;
% end


% Generate a scan in local coordinates
scanPts_local = [];
cpCount = 50;
ths = -2*pi/3 + rand(1,cpCount)*(-pi/3+2*pi/3);
scanPts_local = [scanPts_local, [cos(ths); sin(ths)+2]+0.01*rand(2,cpCount) ];
% lpCount = 30;
% scanPts_local = [scanPts_local, [-2+0.01*rand(1,lpCount); -2+2*rand(1,lpCount) ]];

% Generate particles
%Particles1 = InitiateParticles(100, [-4 4; -3 5; -pi pi], [0, 0, 0]);
%Particles2 = InitiateParticles(100, [-4 4; -3 5; -pi pi], [3, 5, pi/6]);
Particles = InitiateParticles(10000); %20000

Particles_ComputeWorldBelonging;
Particles.wt = Particles_ComputeWeights(scanPts_local);
Particles_Resample(1/10, 0);
% Particles2 = InitiateParticles(100);
% Particles.x = [Particles1.x, Particles2.x];
% Particles.y = [Particles1.y, Particles2.y];
% Particles.th = [Particles1.th, Particles2.th];
% Particles.N = Particles1.N + Particles2.N;

for steps = 1:10

    % Associate particles with different parts of the world and compute the distances
    Particles_ComputeWorldBelonging;
    Particles.wt = Particles_ComputeWeights(scanPts_local);

    Particles_Resample(1/10, 9);
    
    % Propagate the particles
    vel(1) = 2; %1e-6;
    vel(2) = 1; %1e-6;
    dt = 1;
    Particles_Propagate(vel, dt, [0.1; 0.1] );
    Particles.N,

    % Resample particles
    %Particles_Resample(1/10, 9); % [-1 1; -1 1; -pi/2 pi/2]

end

DrawScene('Particles');
%DrawScene('Particles_Weights');
